]> diplodocus.org Git - nmh/blobdiff - test/common.sh.in
Support command issuance and timestamps.
[nmh] / test / common.sh.in
index 5e8d6b3d23fb913edfde179c6b9767fef51b84e2..e86603367c0ef542a961caa13089365599d8284e 100644 (file)
@@ -5,7 +5,11 @@
 #### The following variables are set by "make check".  Ensure
 #### that they are set here so that individual tests can be run
 #### outside of make.  Requires that MH_OBJ_DIR be set on entry.
 #### The following variables are set by "make check".  Ensure
 #### that they are set here so that individual tests can be run
 #### outside of make.  Requires that MH_OBJ_DIR be set on entry.
-test -z "$MH_TEST_DIR"  &&  MH_TEST_DIR="$MH_OBJ_DIR/test/testdir"
+#### Use the result of cd and pwd -P so that the result will agree
+#### with what getcwd(3) returns.
+test -d "$MH_OBJ_DIR/test/testdir"  ||  mkdir -p "$MH_OBJ_DIR/test/testdir"
+test -z "$MH_TEST_DIR" && MH_TEST_DIR=`cd "$MH_OBJ_DIR/test/testdir" && pwd -P`
+export MH_TEST_DIR
 test -z "$MH_INST_DIR"  &&  MH_INST_DIR="${MH_TEST_DIR}/inst"
 test -z "$MH_VERSION"  &&  MH_VERSION="@VERSION@"
 test -z "$prefix"  &&  prefix=@prefix@
 test -z "$MH_INST_DIR"  &&  MH_INST_DIR="${MH_TEST_DIR}/inst"
 test -z "$MH_VERSION"  &&  MH_VERSION="@VERSION@"
 test -z "$prefix"  &&  prefix=@prefix@
@@ -25,14 +29,19 @@ test -z "$ICONV_ENABLED"  &&  ICONV_ENABLED="@ICONV_ENABLED@"
 test -z "$OAUTH_SUPPORT"  &&  OAUTH_SUPPORT="@OAUTH_SUPPORT@"
 test -z "$CURL_USER_AGENT"  &&  CURL_USER_AGENT="@CURL_USER_AGENT@"
 
 test -z "$OAUTH_SUPPORT"  &&  OAUTH_SUPPORT="@OAUTH_SUPPORT@"
 test -z "$CURL_USER_AGENT"  &&  CURL_USER_AGENT="@CURL_USER_AGENT@"
 
+#### Make sure that HOME is set to avoid run-time warning from w3m about
+#### not being able to create config directory.
+HOME="$MH_TEST_DIR"
+export HOME
+
 unset MAILDROP MHBUILD MHCONTEXT MHMTSUSERCONF MHN MHSHOW MHSTORE
 unset MAILDROP MHBUILD MHCONTEXT MHMTSUSERCONF MHN MHSHOW MHSTORE
-unset MHLDEBUG MHPDEBUG MHWDEBUG PAGER
+unset MHLDEBUG MHWDEBUG PAGER XOAUTH SMTPUTF8
 #### Set LC_ALL in individual tests as needed.  Unset these so
 #### that we don't depend on user's settings in other tests.
 unset LANG LC_ALL LC_CTYPE
 
 #### Use a test dir for tmp files when MHTMPDIR applies.
 #### Set LC_ALL in individual tests as needed.  Unset these so
 #### that we don't depend on user's settings in other tests.
 unset LANG LC_ALL LC_CTYPE
 
 #### Use a test dir for tmp files when MHTMPDIR applies.
-MHTMPDIR=$MH_TEST_DIR/Mail
+MHTMPDIR="$MH_TEST_DIR"/Mail
 export MHTMPDIR
 
 #### If you're reading this .... you can set MH_TEST_NOCLEANUP to prevent
 export MHTMPDIR
 
 #### If you're reading this .... you can set MH_TEST_NOCLEANUP to prevent
@@ -61,8 +70,8 @@ fi
 
 test_skip ()
 {
 
 test_skip ()
 {
-  WHY="$1"
-  echo "$Test $0 SKIP ($WHY)"
+  why="$1"
+  echo "$0: skipped: $why"
   exit 77
 }
 
   exit 77
 }
 
@@ -92,10 +101,15 @@ require_prog ()
 }
 
 # Skip test if none of the offered locales are supported.
 }
 
 # Skip test if none of the offered locales are supported.
+# As side effect, use the first locale that is found.  Note that
+# some platforms allow, by way of example, en_US.UTF-8 to be used
+# even though en_US.UTF8 is listed by locale -a.  But by setting
+# LC_ALL here, we don't rely on that.
 require_locale ()
 {
   for locale in "$@"; do
     if locale -a | grep -i "$locale" >/dev/null; then
 require_locale ()
 {
   for locale in "$@"; do
     if locale -a | grep -i "$locale" >/dev/null; then
+        LC_ALL="$locale"; export LC_ALL
         return
     fi
   done
         return
     fi
   done
@@ -138,12 +152,18 @@ check_for_hard_links () {
   set +e
 
   printf '' > "${MH_TEST_DIR}/$$-1"
   set +e
 
   printf '' > "${MH_TEST_DIR}/$$-1"
+  xdir_links_supported=0
   if link "${MH_TEST_DIR}/$$-1" "${MH_TEST_DIR}/$$-2" 2>/dev/null; then
     hard_links_supported=1
   if link "${MH_TEST_DIR}/$$-1" "${MH_TEST_DIR}/$$-2" 2>/dev/null; then
     hard_links_supported=1
+    mkdir "${MH_TEST_DIR}/xlinkdir"
+    if link "${MH_TEST_DIR}/$$-1" "${MH_TEST_DIR}/xlinkdir/$$-2" 2>/dev/null; then
+       xdir_links_supported=1
+    fi
   else
     hard_links_supported=0
   fi
   rm -f "${MH_TEST_DIR}/$$-1" "${MH_TEST_DIR}/$$-2"
   else
     hard_links_supported=0
   fi
   rm -f "${MH_TEST_DIR}/$$-1" "${MH_TEST_DIR}/$$-2"
+  rm -rf "${MH_TEST_DIR}/xlinkdir"
 
   set -e
 }
 
   set -e
 }
@@ -167,7 +187,7 @@ prepare_space() {
 #### Optional arguments:
 ####   'keep first' -- first file is removed unless this is present.
 ####   'ignore space' -- spacing differences will not be considered
 #### Optional arguments:
 ####   'keep first' -- first file is removed unless this is present.
 ####   'ignore space' -- spacing differences will not be considered
-####        signficant, emulating GNU diff -w.  It is assumed that the
+####        significant, emulating GNU diff -w.  It is assumed that the
 ####        first file has already been run through prepare_space.
 ####   ':' <test name> -- will print '<test name>' in the failure message,
 ####        to make it easier to tell which of multiple tests has failed.
 ####        first file has already been run through prepare_space.
 ####   ':' <test name> -- will print '<test name>' in the failure message,
 ####        to make it easier to tell which of multiple tests has failed.
@@ -252,8 +272,77 @@ run_test() {
   fi
 }
 
   fi
 }
 
+#### check_exit() runs the command in $2..., capturing stdout and
+#### stderr, and then tests its exit status with the test(1) condition
+#### in $1.  If that fails, the captured stdout and stderr are
+#### displayed, and $failed incremented.
+check_exit() {
+    c="$1"; shift
+    t="$MH_TEST_DIR/.check_exit"
+    r=0
+    $NMH_TEST_PREFIX "$@" >"$t.1" 2>"$t.2" || r=$?
+    if test $r $c; then
+      rm "$t.1" "$t.2"
+    else
+      echo "$0: check_exit: $r $c failed: $*" >&2
+      echo "    stdout:" >&2
+      sed 's/^/        /' "$t.1" >&2
+      echo "    stderr:" >&2
+      sed 's/^/        /' "$t.2" >&2
+      failed=`expr ${failed:-0} + 1`
+    fi
+}
+
+#### Function invoked by trap on exit.
+cleanup() {
+    #### Save exit status to use as status for this program.
+    status=$?
+
+    #### Clean up test mail space.
+    #### cd to $MH_TEST_DIR before trying to remove its Mail
+    #### subdirectory.  rm on Solaris won't remove it if it's in the
+    #### path of the current working directory.
+    test -z "$MH_TEST_NOCLEANUP" && (cd "$MH_TEST_DIR" && rm -rf "$MH_TEST_DIR"/Mail)
+
+    #### Report test name if set, which indicates failure.
+    #### Relies on set -e to invoke the trap which calls
+    #### this function on failure.
+    #### To use:
+    #### 1) Set test name before running the test, use start_test().
+    #### 2) Unset upon successful completion, use finish_test().
+    if test -n "$nmh_tests_testname"; then
+        echo "first named test failure: $nmh_tests_testname"
+    fi
+
+    #### Exit with non-zero status if failure.  Failure is defined as either
+    #### non-empty nmh_tests_testname or non-zero exit status on entry to the
+    #### function.
+    if test -n "$nmh_tests_testname"  -o  $status -ne 0; then
+        test $status -ne 0  &&  exit $status  ||  exit 1
+        test $status -ne 0  &&  exit 0  ||  exit 0
+    fi
+}
+
+#### Function to set the test name, and whatever the future brings.
+start_test() {
+    #### run_test disables exit on non-zero status, but does increment
+    #### failed.  Don't overwrite nmh_tests_testname if there was a
+    #### failure; remember the first test that failed.
+    [ ${failed:-0} -eq 0 ]  &&  nmh_tests_testname="$1"
+}
+
+#### Corresponding function to indicate that the test has finished.  It need
+#### not be called after each test, just the last one in a file.
+finish_test() {
+    #### run_test disables exit on non-zero status, but does increment
+    #### failed.  Don't unset nmh_tests_testname if there was a failure.
+    [ ${failed:-0} -eq 0 ]  &&  unset nmh_tests_testname
+}
+
 setup_test ()
 {
 setup_test ()
 {
+  set -e
+
   MH="${MH_TEST_DIR}/Mail/.mh_profile"
   MHMTSCONF="${MH_INST_DIR}${nmhetcdir}/mts.conf"
   MH_LIBEXEC_DIR="${MH_INST_DIR}${nmhlibexecdir}"
   MH="${MH_TEST_DIR}/Mail/.mh_profile"
   MHMTSCONF="${MH_INST_DIR}${nmhetcdir}/mts.conf"
   MH_LIBEXEC_DIR="${MH_INST_DIR}${nmhlibexecdir}"
@@ -286,8 +375,9 @@ setup_test ()
   PATH="${MH_INST_DIR}${bindir}:${PATH}"
   export PATH
 
   PATH="${MH_INST_DIR}${bindir}:${PATH}"
   export PATH
 
-  # clean old test data
-  trap "test -z $MH_TEST_NOCLEANUP && (cd $MH_TEST_DIR; rm -rf '$MH_TEST_DIR/Mail')" 0
+  # clean old test data on exit
+  trap cleanup 0
+
   # setup test data
   mkdir -p "$MH_TEST_DIR/Mail" || exit 1
   cat > "$MH" <<EOF || exit 1
   # setup test data
   mkdir -p "$MH_TEST_DIR/Mail" || exit 1
   cat > "$MH" <<EOF || exit 1
@@ -321,6 +411,10 @@ EOF
   fi
 
   folder -create +inbox > /dev/null
   fi
 
   folder -create +inbox > /dev/null
+  #### Suppress warnings about a new version.
+  #### mhparam version includes the nmh- prefix, so be consistent with that.
+  printf 'Version: nmh-%s\n' "${MH_VERSION}" >> "${MH_TEST_DIR}"/Mail/context
+
   # create 10 basic messages
   for i in 1 2 3 4 5 6 7 8 9 10;
   do
   # create 10 basic messages
   for i in 1 2 3 4 5 6 7 8 9 10;
   do